﻿Type=Class
Version=6
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
Sub Class_Globals
	Dim sv As ScrollView

	Private items, nombre, imagenurl As Map
	Private callback As Panel
	Private actividad As Object

	Dim columnas As Int = 2
	Dim columnaactual As Int = 0

	Dim iv As ImageView
	Dim fondo As Panel
	Dim label As Label

	Private anchoborde, fotosize, altotexto, tamañotexto, colorfondo, colortexto, posiciontexto As Int
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(activity As Object, panel1 As Panel, colum As Int, altotext As Int, gravitytext As Int, textsize As Int, colortext As Int, backcolor As Int, borderpic As Int, scrollbarvisible As Boolean)
	callback=panel1
	columnas=colum
	actividad=activity

	nombre.Initialize
	imagenurl.Initialize
	items.Initialize

	sv.Initialize2(0, "sv")
	panel1.AddView(sv,0,0,panel1.Width,panel1.Height)

	altotexto= altotext
	fotosize = panel1.Width / colum
	tamañotexto = textsize
	colortexto = colortext
	colorfondo = backcolor
	anchoborde=borderpic
	posiciontexto=gravitytext
	
	Dim jo = sv As JavaObject
    jo.RunMethod("setVerticalScrollBarEnabled", Array As Object (scrollbarvisible))
End Sub

public Sub add(index As Int, name As String, imageurl As String)
	If columnaactual > columnas-1 Then columnaactual=0

	'posiciona elementos	
	Dim izq As Int = fotosize*columnaactual
	Dim fila As Int = nombre.Size/columnas
	columnaactual=columnaactual + 1
	'registra map elementos
	nombre.Put(nombre.Size,name)
	imagenurl.Put(imagenurl.Size,imageurl)
	items.Put(items.Size,index)

	fondo.Initialize("panel")
	sv.Panel.AddView(fondo,izq,((fotosize+altotexto)*fila),fotosize,fotosize+altotexto+anchoborde)
	fondo.Color=colorfondo
	fondo.Tag = index	
	
	Dim tamimag= ((fondo.width))-(anchoborde*columnas)
	iv.Initialize("")
	fondo.AddView(iv,anchoborde,anchoborde,tamimag,tamimag)

	label.Initialize("")
	label.Text=name
	fondo.AddView(label,anchoborde,fotosize-(anchoborde*(columnas-1)),fondo.Width-(anchoborde*columnas),altotexto)
	label.TextColor=colortexto
	label.TextSize=tamañotexto
	label.Gravity=posiciontexto
	label.Color=Colors.white
	
	'carga imagenes elementos
	GetPicasso.RunMethodJO("load", Array(imageurl)).RunMethodJO("resize", Array(fotosize, fotosize)).RunMethodJO("centerCrop", Null).RunMethodJO("into", Array(iv))
	
	sv.panel.Height= (fila+1) * (fotosize+anchoborde+altotexto)
End Sub


Private Sub panel_Click
	If SubExists(actividad, "grid_ItemClick") Then
		Dim v As View
		v = Sender
		CallSub3(actividad, "grid_ItemClick", v.Tag, items.Get(v.Tag))
	End If
End Sub


Sub remove
	callback.RemoveAllViews

End Sub



Sub Picasso_Event (MethodName As String, Args() As Object) As Object
   Return Null
'   If MethodName = "onSuccess" Then
'     ToastMessageShow("Success!!!", True)
'   Else If MethodName = "onError" Then
'     ToastMessageShow("Error downloading image.", True)
'   End If
'   Return Null
End Sub

Sub GetPicasso As JavaObject
   Dim jo As JavaObject
   'com.squareup.picasso.Picasso.with(context)
   Return jo.InitializeStatic("com.squareup.picasso.Picasso").RunMethod("with", Array(GetContext))
End Sub

Sub GetContext As JavaObject
   Return GetBA.GetField("context")
End Sub

Sub GetBA As JavaObject
  Dim jo As JavaObject
  Dim cls As String = actividad
  cls = cls.SubString("class ".Length)
  jo.InitializeStatic(cls)
  Return jo.GetFieldJO("processBA")
End Sub
